﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Erc {
  using HeuristicLab.Common;
  using HeuristicLab.Core;
  using HeuristicLab.Data;
  using HeuristicLab.Parameters;
  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
  using HeuristicLab.Problems.ProgramSynthesis.Push.Erc.Interfaces;

  [StorableClass]
  public abstract class ErcOption : ParameterizedNamedItem, IReadOnlyErcOption {
    private const string IsEnabledParameterName = "IsEnabled";

    protected ErcOption() {
      Parameters.Add(new FixedValueParameter<BoolValue>(IsEnabledParameterName));
    }

    [StorableConstructor]
    protected ErcOption(bool deserializing) : base(deserializing) { }

    protected ErcOption(ErcOption origin, Cloner cloner) : base(origin, cloner) { }

    public IValueParameter<BoolValue> IsEnabledParameter
    {
      get { return (IValueParameter<BoolValue>)Parameters[IsEnabledParameterName]; }
    }

    public bool IsEnabled
    {
      get { return IsEnabledParameter.Value.Value; }
      set { IsEnabledParameter.Value.Value = value; }
    }
  }
}
